/*
 * @Overview 설비 고장 등록
 */

class Tb_facility_class {
  constructor(container) {
    this.ajax_url = "./reg_faclt_defect.ajax.php";
    this.tbList = "";

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table#main_table")
    this.upBtn = this.container.querySelector(".up-btn") || ""
    this.downBtn = this.container.querySelector(".down-btn") || ""
    this.addBtn = this.container.querySelector(".add-btn") || ""
    this.removeBtn = this.container.querySelector(".remove-btn") || ""
  }

  /*
* @Overview 데이터 조회 함수
* @Parameter mode : AJAX 비동깉 통신 시 사용할 STRING 값, ...test : 조회할 INPUT 태그의 ID 값
*/
  getMainList(mode,...test) {
    const talert= window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);
    let arr = test;
    let data = new Object();
    for(let i=0; i < arr.length; i++){
      let temp = [arr[i]]

      if(document.getElementById(arr[i])?.type !== "checkbox"){
        data[temp] = document.getElementById(temp)?.value
      }else{
        data[temp] = document.getElementById(temp)?.checked?"Y":"N";
      }
    }
    data.mode = mode
    ajax_json({
      url: this.ajax_url,
      data: data,

      success: (data) => {
        if(data.code) {
          this.tbList.setData(data.data);
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
      },
    });
    return true;
  }
  /*
   * @Overview 데이터 필터 함수
   * @Parameter 없음
   * @function 공장, 작업장, 사용 여부 필터링
   */
  setFilter() {


  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    this.tbList.addRow({ _STATUS_: "I" });

  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

        // 선택된 각 행 삭제
        selectedRows.forEach((row) => {
          // STAUS D로 바꾸기
          row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
    
          const rowElement = row.getElement();
          rowElement.classList.add("remove-row");
    
        });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
      this.clearRemove(tgt);
    } else {
      this.tbList.deselectRow();
      tgt.select();

    }
  }

  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  }

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    var editor = tgt.getColumn().getDefinition().editor;
    switch (tgt.getField()) {
      case "USE_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
      case "FACLT_NM":
        popFacility({
          FACLT_CD : "FACLT_CD",
          FACLT_NM: "FACLT_NM"
        },tgt.getRow());
        break;
      default:
        if (!editor) {
          this.rowClick && this.rowClick(e, tgt.getRow());
        }
        break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

  /*
   * @Overview 추가, 수정 및 삭제 데이터 저장
   * @Parameter 없음
   * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
   */
  putData() {
    let _this = this;
    let tempData =  this.tbList.getData().filter( row=> row._STATUS_).filter( row=> row.FACLT_NM !== undefined)
    if(tempData.length == 0){
      this.getMainList();
      return false;
    }
    // 저장 시 상태 변화 없는 row 요청 X
    if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
      this.getMainList();
      return false;
    }

    const blankObj = this.tbList.getData().filter(row => {

      return Object.keys(row).filter(key => key !== '_STATUS_').every(key => {
        const value = row[key];
        return (value === undefined || value === '');
      });
    });

    let postdata = {
      'mode': 'putFacilityDef',
      'reqdata': JSON.stringify(this.tbList.getData().filter(row=> row._STATUS_)),
    };
    if(blankObj.length !== 0){
      kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
        ajax_json({
          url: this.ajax_url,
          data: postdata,
          success: function (data) {
            if (data.code) {
              kuls_success("저장되었습니다.");
              _this.getMainList("getFacilityDef", "FACLT_GRP_P", "FACLT_CD", "FACLT_NM", "date_st", "date_ed");
            }else{
              kuls_alert(data.mesg);
            }
          },
          error: function (request, status, error) {
            kuls_alert(error.message);
          },
          complete: function () {
          }
        });

      },()=>{
        blankObj.forEach(row=>{
          row.getElement().classList.add("blank-row")
        })
      })
    }else {
      ajax_json({
        url: this.ajax_url,
        data: postdata,
        success: function (data) {
          if (data.code) {
            kuls_success("저장되었습니다.");
            _this.getMainList("getFacilityDef", "FACLT_GRP_P", "FACLT_CD", "FACLT_NM", "date_st", "date_ed");
          } else {
            kuls_alert(data.mesg);
          }
        },
        error: function (request, status, error) {
          kuls_alert(error.message);
        },
        complete: function () {
        }
      });
    }
  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    // field 정의
    const fields = [
      {field:"check", title: "삭제", width: 50, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { formatter: "rownum",      title: "NO",     width: 50},
      { field: "FACLT_GRP",        title: "설비그룹",    width: 100},
      { field: "FACLT_NM",        title: "설비",    width: 150,
        editor: tb_custom_editor.pkCode,
        formatter: tb_custom_formatter.pkCode,
        formatterParams : {tableClass: this},
      },
      { field: "FACLT_CD",        visible: false, width: 150},
      { field: "DEFECT_CONTENT",  title: "고장내역", width: 800, editor: "input"},
      { field: "DEFECT_DT",       title: "발생일", width: 150, editor:"date",
        formatter:"datetime",
        formatterParams:{
          inputFormat:"yyyy-MM-dd",
          outputFormat:"yyyy.MM.dd",
        }
      },
    ];
    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      validationMode: "highlight"
    });

    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    this.tbList.on("tableBuilt", () => {
      this.getMainList("getFacilityDef", "FACLT_GRP_P", "FACLT_CD", "FACLT_NM", "date_st", "date_ed");
      
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    this.tbList.on("validationFailed", (cell, value, validators)=>{
      cell.setValue("");
      let errMsg = ""
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e,tgt) => {
      this.cellClick && this.cellClick(e,tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });


    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
    // 엑셀
    ["click", "keypress"].forEach((evt) => {
      const excelBtn = document.querySelector("#excel_data");
      excelBtn.addEventListener(evt, () => {
        tb_common_funtions.tabu2xls_px(this.tbList, "설비고장내역", "설비고장내역")
      });
    });
    // 조회
    ["click", "keypress"].forEach((evt) => {
      const filterBtn = document.querySelector("#filter_btn");
      filterBtn.addEventListener(evt, () => {
        // setFilter 또는 setData
       this.getMainList && this.getMainList("getFacilityDef", "FACLT_GRP_P", "FACLT_CD", "FACLT_NM", "date_st", "date_ed");
      });
    });
    // 저장
    ["click", "keypress"].forEach((evt) => {
      const putBtn = document.querySelector("#put_btn");
      putBtn.addEventListener(evt, () => {
        this.putData();
      });
    });
  }
}


const Tb_facility = new Tb_facility_class("#main_tab");
Tb_facility.init();
